; ##############################################################################
; ##############################################################################
; ##############################################################################
; Messung Zeitstempel															
MFM_ZEIT:
	rcall TIMER3_STOP		; wichtig !!		
	ldi XL,LOW (adr_DATA)	; DATA				
	ldi XH,HIGH(adr_DATA)
	clr temp1				; Zeitstempel		
;-------------------------------------------------------------------------------
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	call FLOPPY_MOTOR_ON						; Motor on	
	rcall FLOPPY_WAIT_INDEX_HIGH				; Index		
	rcall FLOPPY_WAIT_INDEX_LOW					; Index		
;-------------------------------------------------------------------------------
MFM_ZEIT_s1:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM_ZEIT_s1
;-------------------------------------------------------------------------------
MFM_ZEIT_s2:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM_ZEIT_s2
;-------------------------------------------------------------------------------
MFM_ZEIT_s3:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN high	
	rjmp MFM_ZEIT_s3
;-------------------------------------------------------------------------------
MFM_ZEIT_s4:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis DATA-PIN LOW	
	rjmp MFM_ZEIT_s4
;-------------------------------------------------------------------------------
	OUT TCNT0,NULL							; Null					
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
MFM_ZEIT_RUN:
	in temp1,TCNT0						; Zeitstempel	
	OUT TCNT0,NULL						; Null			
;-------------------------------------------------------------------------------
MFM_ZEIT_s:
	sbis (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN HIGH		
	rjmp MFM_ZEIT_s
;-------------------------------------------------------------------------------
; Umrechnung von Zeiten- in Zellenwerte											
	ldi temp2,1		; Zelle1	
	cpi temp1,54
	brlo MFN_ZEIT_w
	ldi temp2,2		; Zelle2	
	cpi temp1,75
	brlo MFN_ZEIT_w
	ldi temp2,3		; Zelle2	
MFN_ZEIT_w:
	ST X+,temp2		; Zeitstempel in Zellenwerten	
;-------------------------------------------------------------------------------
MFM_ZEIT_e:
	sbic (RDDATA_PIN),(RDDATA_PIN_NR)	; Schleife, bis PIN LOW	
	rjmp MFM_ZEIT_e
;-------------------------------------------------------------------------------
	cpi XL,LOW (adr_SRAM_CHECK)			; Ende ?		
	brne MFM_ZEIT_RUN
	cpi XH,HIGH(adr_SRAM_CHECK)			; Ende ?		
	brne MFM_ZEIT_RUN
;-------------------------------------------------------------------------------
; Initialisierung																
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB 			
	ldi XL,LOW (adr_DATA)					; DATA			
	ldi XH,HIGH(adr_DATA)
	ldi YL,LOW (adr_DATA)					; ERGEBNIS		
	ldi YH,HIGH(adr_DATA)
;-------------------------------------------------------------------------------
; Sektor-A suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SECTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SECTOR*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
; Sektor-B suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SECTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SECTOR*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
; Sektor-C suchen und decodieren												
	ldi ZL,  low(TABELLE_ID_SECTOR*2)		; Tabelle		
	ldi ZH, high(TABELLE_ID_SECTOR*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(20)							; Anzahl BYTES	
	ldi ZH,HIGH(20)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
	ldi ZL,  low(TABELLE_ID_DATA*2)			; Tabelle		
	ldi ZH, high(TABELLE_ID_DATA*2)
	call MFM_FIND_XZ						; Muster finden	(X=DATA Z=Tabelle)
	ldi ZL, LOW(580)						; Anzahl BYTES	
	ldi ZH,HIGH(580)
	call MFM_DECODIERUNG_XYZ				; DECODIERUNG (X=DATA Y=Ergebnis Z=AnzBytes	
;-------------------------------------------------------------------------------
	sbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)	; GELB 
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)	; GRN 
;-------------------------------------------------------------------------------
; Ergebnis im SRAM																
	call LCD_CLEAR					; LCD-clear	
	call TEXT_SPUR
	LDS temp1,(adr_DATA+5)
	call LCD_ZAHL2_temp1			; SPUR 		
	call LCD_SPACE

	call TEXT_HEAD
	LDS temp1,(adr_DATA+6)
	call LCD_ZAHL1_temp1			; HEAD		
	call LCD_SPACE

	call LCD_ZEILE2					; LCD-Zeile	
	call LCD_A
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*0)	; Sektor-A	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*0)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*0)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*0)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*0)	; DataBytes3
	call LCD_HEX_TEMP1

	call LCD_ZEILE3					; LCD-Zeile	
	call LCD_B
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*1)	; Sektor-B	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*1)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*1)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*1)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*1)	; DataBytes3
	call LCD_HEX_TEMP1

	call LCD_ZEILE4					; LCD-Zeile	
	call LCD_C
	call LCD_DOPPEL_PUNKT
	LDS temp1,(adr_DATA+7+600*2)	; Sektor-C	
	call LCD_ZAHL2_temp1
	call LCD_MINUS
	LDS temp1,(adr_DATA+25+600*2)	; DataBytes0
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+26+600*2)	; DataBytes1
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+27+600*2)	; DataBytes2
	call LCD_HEX_TEMP1
	call LCD_SPACE
	LDS temp1,(adr_DATA+28+600*2)	; DataBytes3
	call LCD_HEX_TEMP1
;-------------------------------------------------------------------------------
;	call FLOPPY_MOTOR_OFF
;	call RS232_TX_SRAM
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



















