; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP:	X Start-Position														
;		Z (Tabelle)																
; OUT:	X Treffer-Position														
MFM_FIND_XZ:
	WDR
	mov R0,ZL								; Z (Tabelle) sichern	
	mov R1,ZH
	mov R2,XL								; X Start-Position sichern	
	mov R3,XH
;-------------------------------------------------------------------------------
MFM_FIND_RUN:
	mov ZL,R0								; Z (Tabelle) wieder herstellen		
	mov ZH,R1

	add R2,EINS								; X Start-Position + 1 				
	adc R3,NULL
	mov XL,R2
	mov XH,R3

	cpi XL,LOW (adr_SRAM_CHECK)				; berlauf	?	
	brne MFM_FIND_NEXT
	cpi XH,HIGH(adr_SRAM_CHECK)
	brne MFM_FIND_NEXT
	rjmp MFM_FIND_ERROR						; Error			
;-------------------------------------------------------------------------------
MFM_FIND_NEXT:
	LPM R4, Z+ 		  						; Tabellenwert laden	
	tst R4									; Null ?				
	breq MFM_FIND_TREFFER					; Voll-Treffer			
	LD R5, X+								; X laden				
	cp R4,R5								; Vergleich 			
	breq MFM_FIND_NEXT						; Treffer				
	rjmp MFM_FIND_RUN						; no Treffer			
;-------------------------------------------------------------------------------
MFM_FIND_ERROR:
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)		; ROT  an		
	clr XL
	clr XH
	ret
;-------------------------------------------------------------------------------
MFM_FIND_TREFFER:
	mov ZL,R0								; Z (Tabelle) wieder herstellen		
	mov ZH,R1
	clr R3									; length Tabelle
MFM_FIND_s1:
	LPM R2, Z+ 		  						; Wert laden	
	tst R2									; Null ?		
	breq MFM_FIND_ENDE
	inc R3									; length Tabelle
	rjmp MFM_FIND_s1
;-------------------------------------------------------------------------------
; Ergebnis X																	
MFM_FIND_ENDE:
	sub XL,R3								; length Tabelle
	sbc XH,NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; X (DATA)																		
; Y (Ergebnis)																	
; Z (Anzahl BYTES)																
; 																				
MFM_DECODIERUNG_XYZ:
	tst XL
	brne MFM_DECODIERUNG_RUN
	tst XH
	brne MFM_DECODIERUNG_RUN
	ret
;-------------------------------------------------------------------------------
MFM_DECODIERUNG_RUN:
	mov temp4,NULL	; Merkbit=0						
	clr temp8		; Byte							
	ldi temp9,8		; Byte-Counter					
;-------------------------------------------------------------------------------
MFM_DECODIERUNG_s:
	LD temp,X+		; laden							
	cpi temp,1		; Zelle=1						
	breq MFM_Z1
	cpi temp,2		; Zelle=2						
	breq MFM_Z2
	rjmp MFM_Z3		; Zelle=3						
; ##############################################################################
MFM_Z1:				; 1 Zelle: 	Schreibe Merkbit, Merke Merkbit										
	mov temp,temp4	; Merkbit=Merkbit				
	ROR temp		; C kullert raus				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
; ##############################################################################
MFM_Z2:				; 2 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM_Z21		
;-------------------------------------------------------------------------------
MFM_Z20:			; Merkbit 0:Schreibe 0+1, Merke 1
	mov temp4,EINS	; Merkbit=1						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_Z2w	
	ST Y+,temp8		; Byte write************		
	ldi temp9,8		; Byte-Counter					
	sbiw ZL,1		; ZHLER-1						
;-------------------------------------------------------------------------------
MFM_Z2w:
	SEC 			; EINS (Set Carry)				
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
;-------------------------------------------------------------------------------
MFM_Z21:			; Merkbit-1:Schreibe 0, Merke 0	
	mov temp4,NULL	; Merkbit=0						
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
	rjmp MFM_ex		; Exit							
; ##############################################################################
MFM_Z3:				; 3 Zellen:	je nach Merkbit		
	tst temp4		; Merkbit ?						
	brne MFM_Z20	; Merkbit 1:Schreibe 0+1; Merke 1 (wie 2 Zellen)		
;-------------------------------------------------------------------------------
	mov temp4,NULL	; Merkbit 0:Schreibe 0+0; Merke 0
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_Z30w
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
MFM_Z30w:
	CLC 			; NULL (Clear Carry)			
	ROL temp8		; Byte	(C reinschieben links)	
	dec temp9		; Byte-Counter					
	brne MFM_ex		; Exit							
	ST Y+,temp8		; Byte write  ******************
	ldi temp9,8		; Byte-Counter******************
	sbiw ZL,1		; ZHLER-1	  ******************
;-------------------------------------------------------------------------------
MFM_ex:
	tst ZL
	brne MFM_DECODIERUNG_s
	tst ZH
	brne MFM_DECODIERUNG_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

;			  0123456789 0123456789 0123456789									
; Bitmuster: "1111111232 3213232132 3211111112"									
;			 00h A1h A1h A1h FEh												
TABELLE_ID_SECTOR:
.db 1,1,1,1,1,1,1,2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,1,1,2,0,0

;			  0123456789 0123456789 012345678									
; Bitmuster: "1111111232 3213232132 321111131"									
;			 00h A1h A1h A1h FBh												
TABELLE_ID_DATA:
.db 1,1,1,1,1,1,1,2,3,2,3,2,1,3,2,3,2,1,3,2,3,2,1,1,1,1,1,3,1,0,0,0


